#include "Loublocks.h"

//think you should make rotation timer seperate from move timer cause rotation is too fast but moves are too slow
//can be done with one timer if faster and waits number of cycles for moves

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wc;
	DWORD style=WS_CAPTION|WS_MINIMIZEBOX|WS_SYSMENU;

	ZeroMemory(&wc, sizeof(WNDCLASSEX));
	wc.cbSize=sizeof(WNDCLASSEX);
	wc.style=CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc=WndProc;
	wc.hInstance=hInstance;
	wc.hbrBackground=(HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.hIcon= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPICO));
	wc.hIconSm=(HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_APPICO), IMAGE_ICON, 16, 16, NULL);
	wc.hCursor=LoadCursor(NULL, IDC_ARROW);
	wc.lpszClassName=g_ClassName;
	wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);

	if(!RegisterClassEx(&wc))
	{
		MessageBox(0, "Window Registration Failed!", "Error!",
		MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return E_FAIL;
	}

	RECT WindowRect={0,0,WIN_H,WIN_V};
	AdjustWindowRect(&WindowRect,style,TRUE); //Adjust the window to accomodate the window styles

	g_hWnd = CreateWindow(g_ClassName, g_ClassName,
                         style,
						 CW_USEDEFAULT, CW_USEDEFAULT, WindowRect.right-WindowRect.left, WindowRect.bottom-WindowRect.top,
                         NULL, NULL, wc.hInstance, NULL );

	if(!g_hWnd)
	{
		MessageBox(0, "Window Creation Failed!", "Error!",
		MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		UnregisterClass( g_ClassName, wc.hInstance );
		return E_FAIL;
	}

	ShowWindow( g_hWnd, nCmdShow );
	UpdateWindow( g_hWnd );

	SetLevel(0); // this being here sucks but where else?

	MSG msg;
	ZeroMemory( &msg, sizeof(msg) );

	while( msg.message!=WM_QUIT )
	{
		if( GetMessage( &msg, NULL, 0U, 0U))//, PM_REMOVE ) )//0U??? why not just 0
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else
		{
			// no winmessages, idle code here
		}
	}
	ExitGame();
	UnregisterClass( g_ClassName, wc.hInstance );
	return 0;//not msg.wParam???
}



void CheckKeys()
{
	bool key=false;
	if (!GameState.Playing) return;
	
	if (g_Keys[VK_UP])
	{
		DoMove(CLOCKWISE);
		key=TRUE;
	}
//	if (g_Keys[VK_DOWN])
//	{
//		DoMove(DOWN);
//		key=TRUE;
//	}
	if (g_Keys[VK_RIGHT])
	{
		DoMove(RIGHT);
		key=TRUE;
	}
	if (g_Keys[VK_LEFT])
	{
		DoMove(LEFT);
		key=TRUE;
	}
	if (!key)
	{
		KillTimer(g_hWnd,KEY_TIMER_ID);
		runKeyTimer=false;
	}
}

void CALLBACK DownKeyTimer(HWND hWnd, UINT msg, UINT idEvent, DWORD sTime)
{
	if (g_Keys[VK_DOWN])
	{
		DoMove(DOWN);
		UpdateTimer();
	}
	else 
		KillTimer(g_hWnd,DOWN_KEY_TIMER_ID);
}
	
void CALLBACK KeyTimer(HWND hWnd, UINT msg, UINT idEvent, DWORD sTime)
{
	CheckKeys();
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch(msg)
	{
		case WM_CREATE:
		{
			RECT statShpRect={SideStatR.left+4,SideStatR.top+7,SideStatR.right,SideStatR.bottom};
            int i;
			for (i=0;i<6;i++)
			{
				CreateShape(&g_StatShapes[i],i,statShpRect,1,0);
				statShpRect.top+=42;
			}
	
			statShpRect.top+=8;
			CreateShape(&g_StatShapes[i],i,statShpRect,1,0);

			if(!Load())
				ResetScores();

			return 0;
		}
		break;


		case WM_KEYDOWN:
		{
			if (GameState.Playing)
			{
				if (!g_Keys[LOWORD(wParam)])
				{
					g_Keys[LOWORD(wParam)]=true;

				
					if (LOWORD(wParam)==VK_DOWN)
					{
						SetTimer(g_hWnd,DOWN_KEY_TIMER_ID,50,DownKeyTimer);
						return 0;
					}

					if (!runKeyTimer)
					{
						runKeyTimer=true;
						SetTimer(g_hWnd,KEY_TIMER_ID,150,KeyTimer);
						CheckKeys();
					}
				}
				
			}
			return 0;
		}
		break;

		case WM_KEYUP:
		{
			g_Keys[LOWORD(wParam)]=false;
			return 0;
		}
		break;

		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case (ID_GAME_NEW) :
					NewGame();
				break;

				case (ID_GAME_TOPTEN) :
					DialogBox(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_TOPTEN), g_hWnd, TopTenDlg);
				break;

				case (ID_SET_KEYS) :
					DialogBox(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_KEYSETTINGS), g_hWnd, KeySetDlg);
				break;


				case (ID_GAME_EXIT) : PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;


				case (ID_GAME_LEVEL_0) : 
					SetLevel(0);
				break;
				case (ID_GAME_LEVEL_1) : 
					SetLevel(1);
				break;
				case (ID_GAME_LEVEL_2) : 
					SetLevel(2);
				break;
				case (ID_GAME_LEVEL_3) : 
					SetLevel(3);
				break;
				case (ID_GAME_LEVEL_4) : 
					SetLevel(4);
				break;
				case (ID_GAME_LEVEL_5) : 
					SetLevel(5);
				break;
				case (ID_GAME_LEVEL_6) : 
					SetLevel(6);
				break;
				case (ID_GAME_LEVEL_7) : 
					SetLevel(7);
				break;
				case (ID_GAME_LEVEL_8) : 
					SetLevel(8);
				break;
				case (ID_GAME_LEVEL_9) : 
					SetLevel(9);
				break;
			}
			return 0;
		}
		break;

		case WM_TIMER :	if (GameState.Playing) DoMove(DOWN);
			return 0;
		break;

		case WM_PAINT:
		{    
			PAINTSTRUCT PaintStruct;

			HDC hdc=BeginPaint(hWnd, &PaintStruct);     // Tell windows we want to update the window
			
			Redraw(hdc);

			EndPaint(hWnd, &PaintStruct);
			return 0;                                                                           
		}
		
		case WM_DESTROY:
		{
			PostQuitMessage( 0 );
			return 0;
		}

		default : return DefWindowProc( hWnd, msg, wParam, lParam );
	}
}

void SetLevel(int lev)
{
	CheckMenuItem(GetMenu(g_hWnd),LevelID[GameState.StartLevel],MF_UNCHECKED);
	GameState.StartLevel=lev;
	CheckMenuItem(GetMenu(g_hWnd),LevelID[lev],MF_CHECKED);
}



void ResetScores()
{
	for (int i=0; i<10; i++)
	{
		TopTen[i].score=0;
		strncpy(TopTen[i].name,"Anonymous",NAMELENGTH);
	}
}

void Randomise()
{
	srand(GetTickCount());
}

int Random(int highest)
{
	return rand()%highest;
}

void ClearTank()
{
	for (int x=0;x<10;x++)
		for (int y=0;y<20;y++)
		{
			if (g_Tank[x][y])
				DeleteBlock(g_Tank[x][y]);
			g_Tank[x][y]=NULL;
		}
}



bool CheckPosition(int x, int y)
{
	if (x>9||x<0||y<0||y>19||g_Tank[x][y])
		return FALSE;
	return TRUE;
}

void NewShape()
{
	if (GameState.NextShape)
	{
		g_CurrShape=g_NextShape;
		MoveShape(&g_CurrShape,TankR,5,0);
		GameState.Shapes[GameState.NextShapeType]++; //should this kind of method be in the struct it could also setup a new 
		GameState.CurrShape=TRUE;
	}

	RECT temprect=NextR;

	GameState.NextShapeType=Random(7);

	if(GameState.NextShapeType==LINELAYOUT)
	{
			temprect.top+=8;
			temprect.bottom+=8;
	}
	else if (GameState.NextShapeType!=SQLAYOUT)
	{
			temprect.left+=8;
			temprect.right+=8;
	}

	CreateShape(&g_NextShape,GameState.NextShapeType,temprect,2,1);
	GameState.NextShape=TRUE;
}

void ShapeToTank()
{
	int x;
	int y;
	
	for (int i=0;i<4;i++)
	{
		x=g_CurrShape.blocks[i]->xPos;
		y=g_CurrShape.blocks[i]->yPos;
		if (g_Tank[x][y])			//prevents memory leak of already present blocks. for overlapping blocks in tank
		{
			DeleteBlock(g_Tank[x][y]);
			g_Tank[x][y]=NULL;
		}

		g_Tank[x][y]=g_CurrShape.blocks[i];
	}
	
	GameState.CurrShape=FALSE;
}

int CheckLines()
{	//this is rather a complicated procedure but was the simplest way I could manage
	int lines[4];
	int numlines=0;
	int y=0;
	int x=0;

	ZeroMemory(lines,sizeof(int)*4);

	while (y<20&&numlines<4)
	{
		if (x==10)				  //store this full line number and move on to next
		{
			lines[numlines]=y;
			numlines++;
			y++;
			x=0;
		}

		else if (g_Tank[x][y]) //keep moving through current line
			x++;
			
		else //start again on next line
		{
			x=0;
			y++;
		}
	}
	
	if (numlines>0) FlashLines(numlines,lines);//maybe make sure lines=0
				
	for (int l=0;l<numlines;l++)
		for (x=0;x<10;x++)
		{
			DeleteBlock(g_Tank[x][lines[l]]);
			g_Tank[x][lines[l]]=NULL;
			
			for (int y=lines[l];y>0;y--)////////////////+1 here cause i just removed that line???try???
			{
				if (g_Tank[x][y])						//this must go first... not too sure why:(
					MoveBlock(g_Tank[x][y],x,y+1);

				g_Tank[x][y]=g_Tank[x][y-1];			
			}
			g_Tank[x][0]=NULL;
		}

	return numlines;
}

void FlashLines(int num, int lines[4])
{
	DWORD flashtime;

	KillTimer(g_hWnd,1);

	for (int j=0;j<num*2;j++)
	{
		flashtime=GetTickCount()+(500/(num*2));
		
		while (flashtime>GetTickCount());

		for (int i=0;i<4;i++)
		{	
			if (lines[i])
			{
				for (int x=0;x<10;x++)
					g_Tank[x][lines[i]]->raised=!g_Tank[x][lines[i]]->raised;
			}
		}
		HDC hdc=GetDC(g_hWnd);//double buffer this???
		Redraw(hdc);
		ReleaseDC(g_hWnd,hdc);
	}

	UpdateTimer();
}


void RockBottom()	//followed by a peoples elbow! - I couldn't think of a better name
{
	ShapeToTank();
	UpdateScores(CheckLines());

	if (GameState.Playing)
			NewShape();	

	for (int i=0;i<4;i++)
		if (!CheckPosition(g_CurrShape.blocks[i]->xPos,g_CurrShape.blocks[i]->yPos)&&GameState.Playing)
		{
			EndGame();
			break;
		}

	//	else
		//	GameState.Playing=!GameState.Playing;
			
	HDC hdc=GetDC(g_hWnd);
	Redraw(hdc);
	ReleaseDC(g_hWnd,hdc);
}

void UpdateScores(int lines)
{
	if (lines)
	{
		GameState.Lines+=lines;
		GameState.Score+=Scores[lines-1]*(GameState.Level+1);
		if ((GameState.Level<9)&&((GameState.Lines/10)+GameState.StartLevel>GameState.Level))
			GameState.Level++;
	}
	UpdateTimer();
}

void UpdateTimer()
{
	SetTimer(g_hWnd,1,1000-(GameState.Level*100),NULL);
}

void DoMove(int type)
{
	BOOL redraw=TRUE;//perhaps this could be a command instead
	switch (type)
	{
		case LEFT :
		{
			for (int i=0;i<4;i++)
				if (!CheckPosition(g_CurrShape.blocks[i]->xPos-1,g_CurrShape.blocks[i]->yPos))
					redraw=FALSE;	//should a break be included to speed things up? probably wont be noticeable at all

			if (redraw)
				MoveShape(&g_CurrShape,g_CurrShape.xCentre-1,g_CurrShape.yCentre);
		}
		break;

		case RIGHT :
		{
			for (int i=0;i<4;i++)
				if (!CheckPosition(g_CurrShape.blocks[i]->xPos+1,g_CurrShape.blocks[i]->yPos))
					redraw=FALSE;

			if (redraw)
				MoveShape(&g_CurrShape,g_CurrShape.xCentre+1,g_CurrShape.yCentre);
		}
		break;

		case DOWN :
		{
			for (int i=0;i<4;i++)
				if (!CheckPosition(g_CurrShape.blocks[i]->xPos,g_CurrShape.blocks[i]->yPos+1))
				{
					RockBottom();
					redraw=FALSE;
					break;////////////////////////this is needed otherwise rockbottom called 3 or for times!!!!
				}

			if (redraw)
				MoveShape(&g_CurrShape,g_CurrShape.xCentre,g_CurrShape.yCentre+1);
		}
		break;
		
		case ANTICLOCKWISE :
		{
			int i=0;
			int xoffset=0;
			int shiftoffset=0;
			int xDist,yDist;

			if (g_CurrShape.shiftRotate && g_CurrShape.xSize%2==0)//check xsize or ysize? check whole method
				shiftoffset++;

			while(i<4)//perform the checks on the shapes movement
			{
				xDist=g_CurrShape.blocks[i]->xPos-g_CurrShape.xCentre;
				yDist=g_CurrShape.blocks[i]->yPos-g_CurrShape.yCentre;

				if (!CheckPosition(g_CurrShape.xCentre+yDist+xoffset,g_CurrShape.yCentre-xDist+shiftoffset))
				{
					if (xoffset==-2)		//tries moving the shape to the side
						xoffset=1;
					else if (xoffset<1)
						xoffset--;
					else
					{
						redraw=FALSE;
						break;		//if all these attempts have failed rotation cant be performed
					}
					i=-1;
				}
				i++;
			}
			if (redraw)
				RotateShape(&g_CurrShape,type,xoffset);
		}
		break;

		case CLOCKWISE :
		{
			int i=0;
			int xoffset=0;
			int shiftoffset=0;
			int xDist,yDist;


			if (g_CurrShape.shiftRotate && g_CurrShape.ySize%2==0)//check xsize or ysize? check whole method
				shiftoffset++;

			while(i<4)//perform the checks on the shapes movement
			{
				xDist=g_CurrShape.blocks[i]->xPos-g_CurrShape.xCentre;
				yDist=g_CurrShape.blocks[i]->yPos-g_CurrShape.yCentre;

				if (!CheckPosition(g_CurrShape.xCentre-yDist+xoffset+shiftoffset,g_CurrShape.yCentre+xDist))
				{
					if (xoffset==-2)		//tries moving the shape to the side
						xoffset=1;
					else if (xoffset<1)		///////problem what if ---- this will be applied also which could be causing unessary movements on rotation
						xoffset--;
					else
					{
						redraw=FALSE;
						break;		//if all these attempts have failed rotation cant be performed
					}
					i=-1;
				}
				i++;
			}
			if (redraw)
				RotateShape(&g_CurrShape,type,xoffset);
		}
		break;
	}
	if (redraw)
	{
		HDC hdc=GetDC(g_hWnd);
		Redraw(hdc);
		ReleaseDC(g_hWnd,hdc);
	}
}

void Line(HDC hdc, int xstart,int ystart,int xend,int yend)//pen should be selected in to DC before called
{
	if (hdc)
	{
		MoveToEx(hdc,xstart,ystart,NULL);
		LineTo(hdc,xend,yend);		//draws upto but not including this point
	}
}

void DrawBorder(HDC hdc, RECT rect, int thick, BOOL raised)//error checking will need to be better
{
	HPEN FirstPen, SecondPen, oldpen;

	rect.top--;//these adjustments are required to make the border to be drawn outside the rect
	rect.left--;//bottom and right need no adjustment as the GDI only ever fills up to but not including the bottom,right edge 

	if (raised)
	{
		FirstPen=CreatePen(PS_SOLID,NULL,RGB_WHITE);
		SecondPen=CreatePen(PS_SOLID,NULL,RGB_DARK_GRAY);
	}
	else
	{
		FirstPen=CreatePen(PS_SOLID,NULL,RGB_DARK_GRAY);
		SecondPen=CreatePen(PS_SOLID,NULL,RGB_WHITE);
	}

	oldpen=(HPEN)SelectObject(hdc,FirstPen);
	
	for (int i=0;i<thick;i++)//top and left
	{
		Line(hdc,rect.left-i, rect.top-i, rect.right+i, rect.top-i);	//top
		Line(hdc,rect.left-i, rect.top-i, rect.left-i, rect.bottom+i);	//left
	}
	
	SelectObject(hdc,oldpen);
	oldpen=(HPEN)SelectObject(hdc,SecondPen);
	
	for (int i=0;i<thick;i++)//bottom and right
	{
		Line(hdc,rect.right+i, rect.bottom+i, rect.left-i, rect.bottom+i);	//bottom
		Line(hdc,rect.right+i, rect.bottom+i, rect.right+i, rect.top-i);	//right
	}
	
	
	SelectObject(hdc,oldpen);
	
	DeleteObject(FirstPen);
	DeleteObject(SecondPen);
}


void DrawDigits(HDC hdc, RECT rect, int value, int numDigits)
{
	int digit;
	int decDivider=1;
	int xposition=rect.right-DIGITWIDTH;
	HICON numIcon;
	
	for (int i=0;i<numDigits;i++)
	{
		digit=(value%(decDivider*10))/decDivider;//PSEUDO:(remainder from division by 10,100,1000 etc)/into single digit
		decDivider*=10;
		
		numIcon=(HICON)LoadImage(GetModuleHandle(NULL),MAKEINTRESOURCE(DigitIcon[digit]),IMAGE_ICON,NULL,NULL,LR_DEFAULTCOLOR);
		DrawIcon(hdc,xposition,rect.top,numIcon);
		
		xposition-=DIGITWIDTH;
		DestroyIcon(numIcon); //a more effeicient method could be used to prevent constant load and destroy during loop also check for >999
	}
}

void DrawBlock(HDC hdc,Block *blk)
{
	RECT trect=blk->rect;
	trect.bottom-=2;
	trect.right-=2;
	trect.left+=2;
	trect.top+=2;
	FillRect(hdc,&trect,blk->colour);
	DrawBorder(hdc,trect,2,blk->raised);
}

void DrawShape(HDC hdc,Shape *shp)
{
	for (int i=0;i<4;i++)
		DrawBlock(hdc,shp->blocks[i]);
}

void DrawTank(HDC hdc)//need to find a better way to draw to stop flickering either double buffer or just draw shapes part
{
	HBRUSH backBrush=CreateSolidBrush(RGB_LIGHT_GRAY);
	FillRect(hdc,&TankR,backBrush);
	DeleteObject(backBrush);
	DrawBorder(hdc,TankR,3);
	for (int y=0;y<20;y++) for (int x=0;x<10;x++)
		if (g_Tank[x][y])
			DrawBlock(hdc,g_Tank[x][y]);
	
	if (GameState.CurrShape)
		DrawShape(hdc,&g_CurrShape);
}

void NewGame()
{
	if (GameState.CurrShape)
		DeleteShape(&g_CurrShape);
	if (GameState.NextShape)
		DeleteShape(&g_NextShape);
	ClearTank();
	GameState.Clear();
	Randomise();

	NewShape();
	NewShape();
	GameState.Playing=TRUE;
	UpdateTimer();

	HDC hdc=GetDC(g_hWnd);
	Redraw(hdc);
	ReleaseDC(g_hWnd,hdc);
}

void ExitGame()
{
	KillTimer(g_hWnd,1);//error checking i.e. no timer!!!
	
	if (runKeyTimer)
		KillTimer(g_hWnd,KEY_TIMER_ID);

	ClearTank();
	if (GameState.CurrShape)
		DeleteShape(&g_CurrShape);
	if (GameState.NextShape)
		DeleteShape(&g_NextShape);
	for (int i=0;i<7;i++)
		DeleteShape(&g_StatShapes[i]);
}

void DrawNextShape(HDC hdc)
{
	HBRUSH backBrush=CreateSolidBrush(RGB_LIGHT_GRAY);
	FillRect(hdc,&NextR,backBrush);
	DeleteObject(backBrush);
	DrawBorder(hdc,NextR,2);
	if (GameState.NextShape)
		DrawShape(hdc,&g_NextShape);
}

void DrawTopStat(HDC hdc)
{
	HBRUSH backBrush=CreateSolidBrush(RGB_LIGHT_GRAY);
	FillRect(hdc,&TopStatR,backBrush);
	DrawBorder(hdc,TopStatR,2);
	DeleteObject(backBrush);

	DrawBorder(hdc,LinesR,1);
	DrawBorder(hdc,LevelR,1);
	DrawBorder(hdc,ScoreR,1);
	DrawDigits(hdc,LinesR,GameState.Lines,3);
	DrawDigits(hdc,LevelR,GameState.Level,1);
	DrawDigits(hdc,ScoreR,GameState.Score,6);
}

void DrawSideStat(HDC hdc)
{
	HBRUSH backBrush=CreateSolidBrush(RGB_LIGHT_GRAY);
	FillRect(hdc,&SideStatR,backBrush);
	DrawBorder(hdc,SideStatR,2);
	DeleteObject(backBrush);

	RECT tempR={SideStatR.left+71,SideStatR.top+11,SideStatR.left+97,SideStatR.top+34};

	for (int i=0;i<7;i++)
	{
		DrawShape(hdc,&g_StatShapes[i]);
		DrawBorder(hdc,tempR,1);
		DrawDigits(hdc,tempR,GameState.Shapes[i],2);
		tempR.bottom+=42;
		tempR.top+=42;
	}
}

bool Load()
{
	FILE *fp;
	
//better this way? return parameter and calling procedure handles err

	if((fp=fopen("highscores.dat","r"))==NULL)
		return FALSE;
	else
	{
		for (int i=0; i<10; i++)
		{
			fread(&TopTen[i].score,sizeof(int),1,fp);
			fread(&TopTen[i].name,sizeof(char),NAMELENGTH,fp);
			if (ferror(fp))
			{
				fclose(fp);
				return FALSE;
			}
		}
		fclose(fp);		
		return TRUE;
	}
}

bool Save()
{
	FILE *fp;

	if ((fp=fopen("highscores.dat","w"))==NULL)
		return FALSE;
	else
	{
		for (int i=0;i<10;i++)
		{
			fwrite(&TopTen[i].score,sizeof(int),1,fp);
			fwrite(&TopTen[i].name,sizeof(char),NAMELENGTH,fp);
			if (ferror(fp))
			{
				fclose(fp);
				return FALSE;
			}
		}
		fclose(fp);
		return TRUE;
	}
}


int CheckHighScore(int score)
{
	int i=10;

	while (i>0)
	{
		if (score>TopTen[i-1].score)
			i--;
		else 
			break;
	}
	return i;// need to check its not 10
}


int defaultKeys[5]={VK_LEFT,VK_RIGHT,VK_DOWN,VK_SPACE,VK_UP};
//int keys[5];
//keys=defaultKeys;


//Removed from the menu for now, still needs to be implemented
BOOL CALLBACK KeySetDlg(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch (Message)
	{
		case WM_INITDIALOG:
		{
			SetDlgItemText(hWnd, IDC_LEFTKEY, (char *)defaultKeys[0]);
			SetDlgItemText(hWnd, IDC_RIGHTKEY, (char *)defaultKeys[1]);
			SetDlgItemText(hWnd, IDC_DOWNKEY, (char *)defaultKeys[2]);
			SetDlgItemText(hWnd, IDC_ANTIKEY, (char *)defaultKeys[3]);
			SetDlgItemText(hWnd, IDC_CLOCKKEY, (char *)defaultKeys[4]);
		}
		break;

		case WM_COMMAND:
		{
			if LOWORD(wParam==IDOK)
			{
				EndDialog(hWnd, TRUE);//return what??
			}
		}
		break;

		default:
            return FALSE;
	}

	return TRUE;
}

BOOL CALLBACK HighScoreDlg(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch (Message)
	{
		case WM_INITDIALOG:
			SetDlgItemInt(hWnd, IDC_SCORE, GameState.Score,FALSE);
		break;

		case WM_COMMAND:
		{
			if LOWORD(wParam==IDOK)
			{
				int highScorePos=CheckHighScore(GameState.Score);
		
				for (int i=9;i>highScorePos;i--)
				{
					TopTen[i].score=TopTen[i-1].score;
					strcpy(TopTen[i].name,TopTen[i-1].name);
				}
				strncpy(TopTen[highScorePos].name,"",NAMELENGTH);// is this needed if 10 is used in next line
				GetDlgItemText(hWnd, IDC_NAME, TopTen[highScorePos].name, NAMELENGTH);
				TopTen[highScorePos].score=GameState.Score;
				/*if*/ Save();
				EndDialog(hWnd, TRUE);//return what??
			}
		}
		break;

		default:
            return FALSE;
	}

	return TRUE;
}

BOOL CALLBACK TopTenDlg(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch (Message)
	{
		case WM_INITDIALOG:
		{
			for (int i=0;i<10;i++)
			{
				SetDlgItemText(hWnd, TopNamesID[i], TopTen[i].name);
				SetDlgItemInt(hWnd, TopScoresID[i], TopTen[i].score, FALSE);
			}
		}
		break;

		case WM_COMMAND:
		{
			if (LOWORD(wParam==IDOK))
					EndDialog(hWnd, TRUE);//return what??
			else if (LOWORD(wParam==IDC_RESET))
			{
				ResetScores();
				Save();
				EndDialog(hWnd, TRUE);//can i redraw the dialog?
			}
		}
		break;

		default:
            return FALSE;
	}

	return TRUE;
}	
					
void EndGame()
{
	GameState.Playing=FALSE;

	int highScorePos=CheckHighScore(GameState.Score);
	
	KillTimer(g_hWnd,1);//error checking i.e. no timer!!!

	KillTimer(g_hWnd,KEY_TIMER_ID);
	runKeyTimer=false;

	if (highScorePos<10)
		DialogBox(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_HIGHSCORE), g_hWnd, HighScoreDlg);
}
//method1 draw all in one
void Redraw(HDC hdc)
{
	HDC hdcBuffer = CreateCompatibleDC(hdc);
	HBITMAP hbmBuffer = CreateCompatibleBitmap(hdc, WIN_H, WIN_V);
	HBITMAP hbmOldBuffer = (HBITMAP)SelectObject(hdcBuffer, hbmBuffer);
	
	RECT winR;
	GetClientRect(g_hWnd, &winR);

	HBRUSH backBrush=CreateSolidBrush(RGB_LIGHT_GRAY);
	FillRect(hdcBuffer,&winR,backBrush);
	DeleteObject(backBrush);
	

	DrawTank(hdcBuffer);	
	DrawNextShape(hdcBuffer);
	DrawTopStat(hdcBuffer);
	DrawSideStat(hdcBuffer);

	BitBlt(hdc, 0, 0, WIN_H, WIN_V, hdcBuffer, 0, 0, SRCCOPY);

	SelectObject(hdcBuffer, hbmOldBuffer);
	DeleteObject(hbmBuffer);
	DeleteDC(hdcBuffer);
}
//storing number of lines would be good too
//need number limit check

