#ifndef _Shape_h
#define _Shape_h

#include <windows.h>
#include "Colour.h"

#define BLOCKWIDTH 16;
#define BLOCKHEIGHT 16;

//shape types
#define LLAYOUT 0
#define JLAYOUT 1
#define SLAYOUT 2
#define ZLAYOUT 3
#define TLAYOUT 4
#define SQLAYOUT 5
#define LINELAYOUT 6

//Movement operators
#define LEFT 0
#define RIGHT 1
#define DOWN 2
#define ANTICLOCKWISE 3
#define CLOCKWISE 4

typedef struct
{
	int xPos;
	int yPos;
	bool raised;
	HBRUSH colour;
	RECT rect;
} Block;

typedef struct
{
	int xCentre;
	int yCentre;
	int xSize;
	int ySize;
	bool shiftRotate;
	Block *blocks[4];
} Shape;

void MoveBlock (Block *blk, int xpos, int ypos);
void MoveBlock (Block *blk, RECT pRect);
void MoveBlock (Block *blk, RECT pRect, int xpos, int ypos);
void MoveShape (Shape *shp, int xctr, int yctr);
void MoveShape (Shape *shp, RECT pRect);
void MoveShape (Shape *shp, RECT pRect, int xctr, int yctr);
void CreateShape(Shape *shp, int type, RECT pRect, int xctr=4, int yctr=0);
void RotateShape(Shape *shp, int type, int xoffset);
void DeleteBlock(Block *blk);
void DeleteShape(Shape *shp);

#endif
